From e40a3e804320cc18fb780968c79761375a845ee0 Mon Sep 17 00:00:00 2001
From: Alvaro Herrera <alvherre@alvh.no-ip.org>
Date: Fri, 24 Feb 2023 12:02:10 +0100
Subject: [PATCH v3 3/3] have psql \d+ show the constraint name

---
 .../postgres_fdw/expected/postgres_fdw.out    |  20 +-
 contrib/test_decoding/expected/ddl.out        |  50 +-
 src/bin/psql/describe.c                       |  29 +-
 src/test/regress/expected/alter_table.out     |  74 +--
 src/test/regress/expected/collate.out         |   8 +-
 src/test/regress/expected/compression_1.out   |  72 +--
 src/test/regress/expected/copy2.out           |   8 +-
 src/test/regress/expected/create_table.out    | 142 ++---
 .../regress/expected/create_table_like.out    |  88 +--
 src/test/regress/expected/create_view.out     | 348 +++++------
 src/test/regress/expected/domain.out          |  16 +-
 src/test/regress/expected/expressions.out     |  36 +-
 src/test/regress/expected/foreign_data.out    | 580 +++++++++---------
 src/test/regress/expected/generated.out       |  12 +-
 src/test/regress/expected/identity.out        |  16 +-
 src/test/regress/expected/inherit.out         | 138 ++---
 src/test/regress/expected/insert.out          | 118 ++--
 src/test/regress/expected/limit.out           |  32 +-
 src/test/regress/expected/matview.out         |  90 +--
 src/test/regress/expected/polymorphism.out    |  14 +-
 src/test/regress/expected/psql.out            |  40 +-
 src/test/regress/expected/publication.out     |  88 +--
 .../regress/expected/replica_identity.out     |  30 +-
 src/test/regress/expected/rowsecurity.out     |  16 +-
 src/test/regress/expected/rules.out           |  78 +--
 src/test/regress/expected/stats_ext.out       |  10 +-
 src/test/regress/expected/tablesample.out     |  16 +-
 src/test/regress/expected/tablespace.out      |  16 +-
 src/test/regress/expected/triggers.out        |  18 +-
 src/test/regress/expected/updatable_views.out |  34 +-
 src/test/regress/expected/update.out          |  16 +-
 src/test/regress/expected/with.out            |   8 +-
 32 files changed, 1139 insertions(+), 1122 deletions(-)

diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index c8a0bb7b3a..63e9037b20 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -1853,9 +1853,20 @@ describeOneTableDetails(const char *schemaname,
 		appendPQExpBufferStr(&buf,
 							 ",\n  (SELECT pg_catalog.pg_get_expr(d.adbin, d.adrelid, true)"
 							 "\n   FROM pg_catalog.pg_attrdef d"
-							 "\n   WHERE d.adrelid = a.attrelid AND d.adnum = a.attnum AND a.atthasdef)"
-							 ",\n  a.attnotnull");
+							 "\n   WHERE d.adrelid = a.attrelid AND d.adnum = a.attnum AND a.atthasdef)");
 		attrdef_col = cols++;
+		if (verbose && pset.sversion >= 160000)
+		{
+			appendPQExpBuffer(&buf,
+							  ",\n  (SELECT CASE when contype = 'n' THEN conname ELSE '(primary key)' END"
+							  "\n   FROM pg_catalog.pg_constraint co"
+							  "\n   WHERE co.conrelid = '%s' AND co.contype IN ('n', 'p') "
+							  "\n   AND co.conkey @> array[attnum]"
+							  "\n   ORDER BY contype <> 'n' LIMIT 1) AS attnotnull",
+							  oid);
+		}
+		else
+			appendPQExpBufferStr(&buf, ",\n  a.attnotnull");
 		attnotnull_col = cols++;
 		appendPQExpBufferStr(&buf, ",\n  (SELECT c.collname FROM pg_catalog.pg_collation c, pg_catalog.pg_type t\n"
 							 "   WHERE c.oid = a.attcollation AND t.oid = a.atttypid AND a.attcollation <> t.typcollation) AS attcollation");
@@ -2019,7 +2030,8 @@ describeOneTableDetails(const char *schemaname,
 	if (show_column_details)
 	{
 		headers[cols++] = gettext_noop("Collation");
-		headers[cols++] = gettext_noop("Nullable");
+		headers[cols++] = verbose ?  gettext_noop("NOT NULL Constraint") :
+			gettext_noop("Nullable");
 		headers[cols++] = gettext_noop("Default");
 	}
 	if (isindexkey_col >= 0)
@@ -2064,9 +2076,14 @@ describeOneTableDetails(const char *schemaname,
 
 			printTableAddCell(&cont, PQgetvalue(res, i, attcoll_col), false, false);
 
-			printTableAddCell(&cont,
-							  strcmp(PQgetvalue(res, i, attnotnull_col), "t") == 0 ? "not null" : "",
-							  false, false);
+			if (verbose)
+				printTableAddCell(&cont,
+								  PQgetvalue(res, i, attnotnull_col),
+								  false, false);
+			else
+				printTableAddCell(&cont,
+								  strcmp(PQgetvalue(res, i, attnotnull_col), "t") == 0 ? "not null" : "",
+								  false, false);
 
 			identity = PQgetvalue(res, i, attidentity_col);
 			generated = PQgetvalue(res, i, attgenerated_col);
